import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api/index';
import type { GoodsAttrResult, GoodsAttrResultParam } from './model';
import { MODULES_API_URL } from '@/config/setting';

/**
 * 分页查询商品属性详情表
 */
export async function pageGoodsAttrResult(params: GoodsAttrResultParam) {
  const res = await request.get<ApiResult<PageResult<GoodsAttrResult>>>(
    MODULES_API_URL + '/shop/goods-attr-result/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询商品属性详情表列表
 */
export async function listGoodsAttrResult(params?: GoodsAttrResultParam) {
  const res = await request.get<ApiResult<GoodsAttrResult[]>>(
    MODULES_API_URL + '/shop/goods-attr-result',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加商品属性详情表
 */
export async function addGoodsAttrResult(data: GoodsAttrResult) {
  const res = await request.post<ApiResult<unknown>>(
    MODULES_API_URL + '/shop/goods-attr-result',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改商品属性详情表
 */
export async function updateGoodsAttrResult(data: GoodsAttrResult) {
  const res = await request.put<ApiResult<unknown>>(
    MODULES_API_URL + '/shop/goods-attr-result',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除商品属性详情表
 */
export async function removeGoodsAttrResult(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/shop/goods-attr-result/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除商品属性详情表
 */
export async function removeBatchGoodsAttrResult(data: (number | undefined)[]) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/shop/goods-attr-result/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询商品属性详情表
 */
export async function getGoodsAttrResult(id: number) {
  const res = await request.get<ApiResult<GoodsAttrResult>>(
    MODULES_API_URL + '/shop/goods-attr-result/' + id
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}
